=== debian/changelog ===
rspamd (3.13.2-1) unstable; urgency=medium

  * New upstream version 3.13.2

 -- Jerome Lebleu <jerome@maroufle.fr>  Thu, 30 Oct 2025 09:22:29 +0100
