=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/rspamd-$1\.tar\.gz/ \
  https://github.com/rspamd/rspamd/tags .*/v?(\d\S*)\.tar\.gz
